autowatch = 1;

function Closure() {
  var foo = 1;
  this.bar = 2;

  this.Foo = function() {
    post('Foo');
    post(foo, '\n');
  };

  this.Bar = function() {
    post('\nBar');
    post(this.bar, '\n');
  };
};

var cl = new Closure();

post('*** immediate ***\n');
cl.Foo();
cl.Bar();


post('*** apply (no this) ***\n');
cl.Foo.apply();
cl.Bar.apply();


post('*** apply (with this) ***\n');
cl.Foo.apply(cl);
cl.Bar.apply(cl);


post('\n*** execute ***\n');

var foo_task = new Task(cl.Foo, cl);
var bar_task = new Task(cl.Bar, cl);

foo_task.execute();
bar_task.execute();


post('\n*** schedule ***\n');
foo_task.schedule(100);
bar_task.schedule(200);

/* Results:

  *** immediate ***
  Foo  1
  Bar  2

  *** apply (no this) ***
  Foo  1
  Bar  <undefined>

  *** apply (with this) ***
  Foo  1
  Bar  2

  *** execute ***
  Foo
  Bar  2

  *** schedule ***
  Foo
  test.  Javascript ReferenceError: foo is not defined, line 8
  Bar  2
*/

function Cl2() {
  this.closure = new Closure();
  this.Foo = function() {
    post('superFOO\n');
    this.closure.Foo();
  };
};

var cl2 = new Cl2();

var task3 = new Task(cl2.Foo, cl2);
task3.schedule(250);
