#ifndef __COMMAND
#define __COMMAND

#include "util/apply.js"
#include "util/reader.js"
#include "max/inout.js"
#include "max/max_objects.js"

_in([
     ['midi', 'Commands from MIDI instruments'],
     ['commands', 'filenames of commands'],
     ]);

_out([
      ['display',    'Data to the display area.'],
      ]);


function _make_processors(processors) {
  var result = {};
  for (var name in processors) {
    var proc = processors[name];
    var context = proc();
    result[name] = function(filename) {
      return Reader.ReadData(filename, context);
    };
  }
  return result;
};



var _command_file_context = _make_processors(
  {
    'Group': Group(),
    'InletProcessor': InletProcessor(),
    'Midi': Midi(),
    'ProgramChange': ProgramChange(),
    'Song': Song(),
  }
);


function anything(arg) {
  if (inlet)

  else
    _process_input(_inlet_name(), arrayfromargs(arguments), _input_map);

};

#endif  // __COMMAND
