#ifndef __BUILDER_FROM_MPATCHER
#define __BUILDER_FROM_PATCHER

#include "creator/creator.js"
#include "util/set.js"

Creator.BuilderFromPatcher = function(boxes, lines) {
  boxes = boxes || [];
  lines = lines || [];
  builder = {};
  builder.create = {};

  var defaults = {
    'fontname': 'Arial',
    'fontsize': 12,
    'mode': 0,
    'parameter_enable': 1,
  };

  for (var i = 0; i < boxes.length; ++i) {
    var ignore = new Set();
    var box = boxes[i].box;
    var class = box.maxclass;
    if (class == 'newobj') {
      class = box.text;
      ignore.Add('text');
    }

    for (var name in defaults) {
      if (box[name] == defaults[name])
        ignore.Add(name);
    }

    var rect = box.patching_rect;
    var builder = [class].concat(rect);
    for (var name in box) {
      if (!(ignore.Has(name) || Creator.MaxFieldsToIgnore.Has(name))) {
        var v = box[name];
        if (name == 'presentation_rect') {
          v = [v[0] - rect[0], v[1] - rect[1], v[2] - rect[2], v[3] - rect[3]];
          if (!(v[0] || v[1] || v[2] || v[3]))
            continue;
        }

        builder.push([name, v]);
      }
    }

    builder.create[box.id] = builder;
  }

  builder.connect = [];
  for (var i = 0; i < lines.length; ++i) {
    var line = lines[i].patchline;
    builder.connect.push([line.source[0], line.source[1],
                          line.destination[0], line.destination[1], line.hidden])
  }
  return builder;
};

Creator.MaxFieldsToIgnore = new Set(
  'id',
  'maxclass',
  'numinlets',
  'numoutlets',
  'outlettype',
  'patching_rect',
  'saved_attribute_attributes'
);

#endif  // __BUILDER_FROM_PATCHER
