#include "creator/builder.js"
#include "max/mock_patcher.js"
#include "util/reader.js"

Testing.TestFunction(function() {
  Max.patcher = new MockPatcher();

  var filedata = Reader.ReadFile('js/creator/builder_test.data');
  var objects = Creator.CreateAndConnect(Creator.Builder(filedata), {'x':2, 'y':3});

  var expected = [['newdefault', 7, 15, 'textedit'],
                  ['m-textedit-0()', 'set', 'text here'],
                  ['newdefault', 24, 37, 'button'],
                  ['m-button-1()', 'inputenable', true],
                  ['m-button-1()', 'set', 's1'],
                  ['newdefault', 14, 26, 'button'],
                  ['m-button-2()', 'inputenable', true],
                  ['m-button-2()', 'set', 'st 2'],
                  ['connect', 'm-textedit-0', 1, 'm-button-1', 0, ],
                  ['connect', 'm-textedit-0', 1, 'm-button-2', 0, ],
                 ];
  Testing.ExpectEqual('builder', Max.patcher.commands, expected);
});

