#ifndef __MAX_WRITE_BUILDER
#define __MAX_WRITE_BUILDER

#include "creator/creator.js"

Creator.WriteBuilder = function(builder, write) {
  write('{\n');
  write("  'create': {\n");
  for (var name in builder.create) {
    write("    '" + name + "':\n");
    var creator = builder.create[name];
    var parts = ["'" + creator[0] + "'"].concat(creator.slice(1, 5));
    write("      [" + parts.join(', '));
    if (creator.length > 5) {
      write(',\n');
      for (var i = 5; i < creator.length; ++i)
        write("        " + Print(creator[i]) + ",\n");
      write("      ");
    }
    write("],\n\n");
  };
  write("  },\n\n");

  if (builder.connect.length) {
    write("  'connect': [\n");
    for (var i = 0; i < builder.connect.length; ++i)
      write("    " + Print(builder.connect[i]) + ",\n");
    write("  ]\n");

    write("}\n");
  }
};

#endif  // __MAX_WRITE_BUILDER
