#include "cycle/cycle.js"

Testing.TestFunction(function() {
  function Cyc(_) {
    return new Cycle(arrayfromargs(arguments));
  };

  var cycle = Cyc(1, 2, 3);
  Testing.ExpectEqual('cycle', cycle.list, [1, 2, 3]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 0);
  Testing.ExpectEqual('cycle', cycle.Get(1), 1);
  Testing.ExpectEqual('cycle', cycle.Advance(), true);
  Testing.ExpectEqual('cycle', cycle.Get(1), 2);

  cycle = Cyc(Cyc(1, 2), Cyc(3, Cyc(4, 5)));
  Testing.ExpectEqual('cycle', cycle.Get(1).list, [1, 2]);
  Testing.ExpectEqual('cycle', cycle.Get(2), 1);
  cycle.Advance();
  cycle.Get(1).Advance();
  cycle.Get(2).Advance();
  Testing.ExpectEqual('cycle', cycle.Get(3), 5);

  cycle = Cyc();
  Testing.ExpectEqual('cycle', cycle.list, []);
  Testing.ExpectEqual('cycle', cycle.selected_index, 0);

  cycle.Insert(0);
  Testing.ExpectEqual('cycle', cycle.list, [0]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 0);

  cycle = Cyc();
  cycle.Insert(0);
  Testing.ExpectEqual('cycle', cycle.list, [0]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 0);

  cycle.Insert(1);
  Testing.ExpectEqual('cycle', cycle.list, [0, 1]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 1);

  cycle = Cyc();
  cycle.Insert(0);
  cycle.Insert(1, 0);
  Testing.ExpectEqual('cycle', cycle.list, [0, 1]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 1);

  cycle = Cyc();
  cycle.Insert(0);
  cycle.Insert(1, 1);
  Testing.ExpectEqual('cycle', cycle.list, [0, 1]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 0);

  cycle.Insert(-1, -1);
  Testing.ExpectEqual('cycle', cycle.list, [-1, 0, 1]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 1);

  cycle.Insert(2);
  Testing.ExpectEqual('cycle', cycle.list, [-1, 0, 2, 1]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 2);

  cycle.Remove(3);
  Testing.ExpectEqual('cycle', cycle.list, [-1, 0, 2]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 2);

  cycle.Remove(0);
  Testing.ExpectEqual('cycle', cycle.list, [0, 2]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 1);

  cycle.Remove(0);
  Testing.ExpectEqual('cycle', cycle.list, [2]);
  Testing.ExpectEqual('cycle', cycle.selected_index, 0);

  cycle.Remove(0);
  Testing.ExpectEqual('cycle', cycle.list, []);
  Testing.ExpectEqual('cycle', cycle.selected_index, 0);
});
