#include "cycle/level_manager.js"
#include "cycle/mock_group_data.js"

Testing.TestFunction(function() {
  var level_manager = new LevelManager(4);

  var x = new Object();
  level_manager.Assign(0, x);
  Testing.ExpectEqual('level_manager',
                      level_manager.Get(4).list[0].list[0].list[0].list, [x]);
  Testing.ExpectEqual('level_manager', level_manager.Get(0), x);
  Testing.ExpectEqual('level_manager', level_manager.Get(1).list, [x]);

  level_manager.Assign(1, new Cycle([x]));
  Testing.ExpectEqual('level_manager',
                      level_manager.Get(4).list[0].list[0].list[0].list, [x]);
  Testing.ExpectEqual('level_manager', level_manager.Get(0), x);
  Testing.ExpectEqual('level_manager', level_manager.Get(1).list, [x]);

  level_manager.Create(3, 'patches', MockGroupData());
  level_manager.Create(4, 'patches-set', [['patches']]);

  Testing.ExpectEqual('level_manager', level_manager.Get(0)(),
                      ['vl', 'Clarinet']);
});
