#ifndef __NAMED_CYCLE
#define __NAMED_CYCLE

#include "cycle/cycle.js"

// NamedCycle takes a nested list and a depth to apply it to.
function NamedCycle(list, depth) {
  var named_cycle = new Cycle(list);

  // If the first entry of this list is a string, slice and store it as the name
  // of this cycle list.
  if (list.length && typeof(list[0]) == 'string') {
    named_cycle.name = list[0];
    list = list.slice(1);
    named_cycle.list = list;
  }

  if (depth) {
    for (var i = 0; i < list.length; ++i)
      list[i] = NamedCycle(list[i], depth - 1);
  }

  return named_cycle;
};

#endif  // __NAMED_CYCLE
