#include "cycle/named_cycle.js"

Testing.TestFunction(function() {
  var res = NamedCycle([['foo', 'bar']], 1);
  Testing.ExpectEqual('named_cycle', res.list[0].list, ['bar']);
  Testing.ExpectEqual('named_cycle', res.list[0].name, 'foo');

  var res = NamedCycle([['clarinet', ['vl', 'Clarinet'], ['vl', 'Bass Cl']],
                           [['vl', 'Alto'], ['vl', 'MyAlto']]], 1);

  Testing.ExpectEqual('named_cycle', res.list[0].name, 'clarinet');
  Testing.ExpectEqual('named_cycle', res.list[1].name, undefined);

  var group_data =
    [
      ['reeds',
       ['clarinet', ['vl', 'Clarinet'], ['vl', 'Bass Cl']],
       ['alto sax', ['vl', 'Alto'], ['vl', 'MyAlto']],
      ],
      ['brass',
       ['horns', ['vl', 'Horn']],
      ]
    ];

  var groups = NamedCycle(group_data, 2);

  function do_test(song, section, patch) {
    Testing.ExpectEqual('named_cycle', groups.Get(1).name, song);
    Testing.ExpectEqual('named_cycle', groups.Get(2).name, section);
    Testing.ExpectEqual('named_cycle', groups.Get(3)[1], patch);
  };

  do_test('reeds', 'clarinet', 'Clarinet');

  groups.Advance();
  do_test('brass', 'horns', 'Horn');

  groups.Advance();
  do_test('reeds', 'clarinet', 'Clarinet');

  groups.Get(1).Advance();
  do_test('reeds', 'alto sax', 'Alto');

  groups.Get(1).Advance(-1);
  do_test('reeds', 'clarinet', 'Clarinet');

  groups.Get(2).Advance(-1);
  do_test('reeds', 'clarinet', 'Bass Cl');

  groups.Get(1).Advance();
  do_test('reeds', 'alto sax', 'Alto');

  groups.Get(2).Advance();
  do_test('reeds', 'alto sax', 'MyAlto');

  groups.Advance();
  do_test('brass', 'horns', 'Horn');
});
