#ifndef __NAMED_LEVEL_MANAGER
#define __NAMED_LEVEL_MANAGER

#include "cycle/level_manager.js"

function NamedLevelManager(names) {
  var level_manager = new LevelManager(names.length);
  var me = this;

  function Level(level) {
    for (var i = 0; i < names.length; ++i)
      if (level == i || level == me.context[names[i]])
        return i;
  };

  this.context = {
    'Assign': level_manager.Assign,

    'Advance': function(level, delta) {
      return level_manager.Advance(Level(level), delta);
    },
  };

  function CreateLevel(level) {
    return function(name, desc) {
      level_manager.Create(Level(level), name, desc);
    };
  };

  for (var i in names)
    this.context[names[i]] = CreateLevel(i);

  this.Get = function(level) {
    return level_manager.Get(Level(level));
  };
};

#endif  // __NAMED_LEVEL_MANAGER
