#ifndef __BOUNDING_RECTANGLE
#define __BOUNDING_RECTANGLE

// CombineRectangles() returns the smallest rectangle that contains rectangles
// r1 and r2.
function CombineRectangles(r1, r2) {
  if (!r1)
    return r2;
  if (!r2)
    return r1;

  function Min(x, y) { return (x < y) ? x : y; };
  function Max(x, y) { return (x > y) ? x : y; };

  var x = Min(r1[0], r2[0]);
  var y = Min(r1[1], r2[1]);
  var rightx = Max(r1[0] + r1[2], r2[0] + r2[2]);
  var bottomy = Max(r1[1] + r1[3], r2[1] + r2[3]);
  return [x, y, rightx - x, bottomy - y];
};

// BoundingRectangle returns the smallest rectangle containing the given items
// and rectangle (which may be empty).
function BoundingRectangle(items, rect) {
  if (!items)
    return undefined;

  if (items.rect)
    return CombineRectangles(rect, items.rect);

  for (var i in items)
    rect = BoundingRectangle(items[i], rect);

  return rect;
};

#endif  // __BOUNDING_RECTANGLE
