#include "max/callback.js"
#include "max/mock_outlet.js"

Testing.TestFunction(function() {
  var variables = new Object();
  Callback.AddTexteditOutlet(variables, {'a': 'aa', 'b': 'bb'});
  Callback.AddOutlet(variables, ['c'], 1);

  Testing.results = [];
  variables.a = 1;
  Testing.ExpectEqual('outlet_callback', variables.a, 1);
  Testing.ExpectEqual('outlet_callback', Testing.results,
                      [[0, 'aa', 'set', '1']]);

  Testing.results = [];
  variables.c = 2;
  Testing.ExpectEqual('outlet_callback', variables.c, 2);
  Testing.ExpectEqual('outlet_callback', Testing.results,
                      [[1, 'c', 2]]);

  Testing.results = [];
  variables.d = 4;
  Testing.ExpectEqual('outlet_callback', variables.d, 4);
  Testing.ExpectEqual('outlet_callback', Testing.results, []);

  function TestClass() {
    this.x = 3;
    this.F = function(x, y, z) {
      return x + y + z;
    };
  };

  var object = new TestClass();
  var context = {};
  Callback.AddInlet(context, object, ['x', 'F']);

  var res1 = context.x(10);  // Sets x to 10.
  var res2 = context.x();  // Gets x.
  var res = context.f(1, 2, 3);  // Calls F(1, 2, 3);

  Testing.ExpectEqual('inlet_callback', object.x, 10);
  Testing.ExpectEqual('inlet_callback', res1, 10);
  Testing.ExpectEqual('inlet_callback', res2, 10);
  Testing.ExpectEqual('inlet_callback', res, 6);
});
