#ifndef __MAX_CONNECT
#define __MAX_CONNECT

#include "max/max.js"
#include "max/deref.js"
#include "max/patcher.js"

Max.ConnectOne = function(max_objects, from, from_inlet, to, to_inlet, hidden) {
  from = Max.Deref(max_objects, from);
  to = Max.Deref(max_objects, to);
  if (hidden)
    Max.patcher.hiddenconnect(from, from_inlet, to, to_inlet);
  else
    Max.patcher.connect(from, from_inlet, to, to_inlet);
};

// Connect a list of Max items together.
//
// Each entry in connections looks like:
//  [from, from_index, to, to_index, hidden]
//
// to and from are string, or lists of strings.
Max.Connect = function(connections, max_objects) {
  for (var i = 0; i < connections.length; ++i)
    Max.ConnectOne.apply(this, [max_objects].concat(connections[i]));
};

#endif  // __MAX_CONNECT
