#ifndef __CONNECTIONS
#define __CONNECTIONS

#include "max/patcher.js"

function Connections() {
  var connections = [];

  this.connect = function(from, to, replace) {
    var ft = [from, to];
    for (var i in connections) {
      if (ft[0] == connections[i][0] && ft[1] == connections[i][1])
        return false;
    }
    if (replace) {
      this.clear(from);
      this.clear(to);
    }
    Max.patcher.connect(from, 0, to, 0);
    connections.push(ft);
    return true;
  };

  this.clear = function(object) {
    // Clear all connections to an object.
    // An empty object means "clear everything".
    var result = []
    for (var i = 0; i < connections.length; ++i) {
      var con = connections[i];
      var from = con[0];
      var to = con[1];
      if (object && object !== from && object !== to)
        result.push(con);
      else
        Max.patcher.disconnect(from, 0, to, 0);
    }
    connections = result;
  };
};

#endif  // __CONNECTIONS
