#include "max/connections.js"
#include "max/mock_patcher.js"

Testing.TestFunction(function() {
  Max.patcher = new MockPatcher();

  var connections = new Connections();
  Testing.ExpectEqual('connections', connections.connect('a', 'b'), true);
  Testing.ExpectEqual('connections', connections.connect('a', 'b'), false);
  connections.connect('a', 'c');
  connections.connect('a', 'd');
  connections.connect('b', 'd');
  connections.connect('d', 'e');

  Testing.ExpectEqual('connections', Max.patcher.commands,
                      [['connect', 'a', 0, 'b', 0],
                       ['connect', 'a', 0, 'c', 0],
                       ['connect', 'a', 0, 'd', 0],
                       ['connect', 'b', 0, 'd', 0],
                       ['connect', 'd', 0, 'e', 0],
                       ]);

  Max.patcher = new MockPatcher();
  connections.connect('a', 'e', true);

  Testing.ExpectEqual('connections', Max.patcher.commands,
                      [['disconnect', 'a', 0, 'b', 0],
                       ['disconnect', 'a', 0, 'c', 0],
                       ['disconnect', 'a', 0, 'd', 0],
                       ['disconnect', 'd', 0, 'e', 0],
                       ['connect', 'a', 0, 'e', 0],
                       ]);

  Max.patcher = new MockPatcher();
  connections.clear();

  Testing.ExpectEqual('connections', Max.patcher.commands,
                      [
                       ['disconnect', 'b', 0, 'd', 0],
                       ['disconnect', 'a', 0, 'e', 0],
                       ]);
  });
