#ifndef __MAX_OBJECTS
#define __MAX_OBJECTS

#include "max/connections.js"
#include "max/clear_maxobjs.js"
#include "max/create_midiinout.js"

function MaxObjects(js) {
  this.max_objects = {};
  var connections = new Connections();
  var me = this;

  this.context = {
    'Clear': function() {
      connections.clear();
      ClearMaxobjs('patcher', 'route');
      me.max_objects = {};
    },

    'Connect': function(midiin, midiout, parallel) {
      connections.connect(me.max_objects.tmidiin[midiin],
                          me.max_objects.tmidiout[midiout],
                          parallel);
    },

    'Create': function(desc) {
      me.context.Clear();
      me.max_objects = CreateMidiInOut(desc, js);
    },
  };
};


#endif  // __MAX_OBJECTS
