#include "max/max_objects.js"
#include "max/mock_patcher.js"

Testing.TestFunction(function() {
  Max.patcher = new MockPatcher();
  var max_objects = new MaxObjects(Max.patcher.js);
  max_objects.context.Create(
      {'tmidiin': {'foo':'Foo', 'bar': 'Bar', 'baz': 'Baz'},
       'tmidiout': {'bing': 'Bing', 'bang': 'Bang'}}, Max.patcher.js);

  Testing.ExpectEqual('max_objects', Max.patcher.commands,
              [
               ['newdefault', 8, 80, 'route', ['tmidiin', 'tmidiout']],
               ['connect', 'js', 0, 'm-route-0', 0],
               ['newdefault', 8, 112, 'route', ['foo', 'bar', 'baz']],
               ['connect', 'm-route-0', '0', 'm-route-1', 0],
               ['newdefault', 8, 144, 'tmidiin', 'foo'],
               ['connect', 'm-route-1', 0, 'm-tmidiin-2', 0],
               ['connect', 'm-tmidiin-2', 1, 'js', 0],
               ['newdefault', 86, 144, 'tmidiin', 'bar'],
               ['connect', 'm-route-1', 1, 'm-tmidiin-3', 0],
               ['connect', 'm-tmidiin-3', 1, 'js', 0],
               ['newdefault', 164, 144, 'tmidiin', 'baz'],
               ['connect', 'm-route-1', 2, 'm-tmidiin-4', 0],
               ['connect', 'm-tmidiin-4', 1, 'js', 0],
               ['newdefault', 242, 112, 'route', ['bing', 'bang']],
               ['connect', 'm-route-0', '1', 'm-route-5', 0],
               ['newdefault', 242, 144, 'tmidiout', 'bing'],
               ['connect', 'm-route-5', 0, 'm-tmidiout-6', 0],
               ['newdefault', 332, 144, 'tmidiout', 'bang'],
               ['connect', 'm-route-5', 1, 'm-tmidiout-7', 0],
               ]);
});
