#ifndef __MOCK_PATCHER
#define __MOCK_PATCHER

#include "max/callback.js"

function MockPatcher() {
  var commands = [];
  this.commands = commands;

  function MakeConnector(name) {
    return function(from, outlet, to, inlet) {
      commands.push([name, from.name || from, outlet, to.name || to, inlet]);
    };
  };
  var names = ['connect', 'disconnect', 'hiddenconnect'];
  for (var i in names)
    this[names[i]] = MakeConnector(names[i]);

  this.remove = function(object) {
    commands.push(['remove', object.name]);
  };

  function MockMaxobj(left, top, maxclass, name) {
    var maxobj = new Object();

    maxobj.maxclass = maxclass;
    maxobj.name = name;
    maxobj.message = function(_) {
      commands.push([name + '()'].concat(arrayfromargs(arguments)));
    };
    maxobj.rect = [left, top, 69, 16];
    // Don't turn this on as all the tests get too spammy!
    // Callback.Add(maxobj, 'rect', Mock('rect.' + name));

    return maxobj;
  };

  this.firstobject = MockMaxobj(0, 0, 'js', 'js');
  this.js = this.firstobject;

  var lastobject = this.firstobject;

  var maxobj_index = 0;

  this.newdefault = function(left, top, name, _) {
    commands.push(['newdefault'].concat(arrayfromargs(arguments)));

    var obj = MockMaxobj(left, top, name, 'm-' + name + '-' + (maxobj_index++));
    lastobject.nextobject = obj;
    lastobject = obj;
    return obj;
  };

  this.apply = function(f) {
    for (var obj = this.firstobject; obj; obj = obj.nextobject)
      f(obj)
  };
};

#endif  // __MOCK_PATCHER

