#include "morse/callbacks.js"
#include "morse/generator.js"

Testing.TestFunction(function() {
  Testing.results = [];
  var index = 0;

  var context = {};
  var generator = new Morse.Generator();
  Morse.AddCallbacks(generator, context);
  generator.Init();
  generator.Mode('stream');

  generator.tasker.NewTask = function() {
    var result = new Object();
    result.schedule = function(time) {
      Testing.results.push(['schedule', time]);
    };

    result.cancel = function() {};
    return result;
  };

  Testing.ExpectFunction('generator', generator.KeyIn, generator, ['a'],
                         [[0, 'letter_queue', 'set', 'a'],
                          [0, 'current_letter', 'clear'],
                          [0, 'current_letter', 'set', 'a'],
                          [0, 'symbol_queue', 'set', '.-'],
                          [0, 'makenote', 64, 64, 60],
                          ['schedule', 120],
                          ],
                         true);
  Testing.ExpectEqual('generator', generator.tasker.running, true);
  Testing.ExpectEqual('generator', generator.end_of_message, false);

  Testing.ExpectFunction('generator',
                         generator.tasker.Execute, generator.tasker, [],
                         [[0, 'symbol_queue', 'set', '-'],
                          [0, 'makenote', 64, 64, 180],
                          ['schedule', 360],
                          ],
                         true);
  Testing.ExpectEqual('generator', generator.tasker.running, true);
  Testing.ExpectEqual('generator', generator.end_of_message, false);

  Testing.ExpectFunction('generator',
                         generator.tasker.Execute, generator.tasker, [],
                         [[0, 'symbol_queue', 'clear'],
                          ['schedule', 360]],
                         true);
  Testing.ExpectEqual('generator', generator.tasker.running, true);
  Testing.ExpectEqual('generator', generator.end_of_message, true);

  Testing.ExpectFunction('generator',
                         generator.tasker.Execute, generator.tasker, [],
                         [[0, 'letter_queue', 'clear'],
                          [0, 'current_letter', 'clear'],
                          ],
                         true);
  Testing.ExpectEqual('generator', generator.tasker.running, false);

  Testing.ExpectFunction('generator', generator.KeyIn, generator, ['a'],
                         [[0, 'letter_queue', 'set', 'a'],
                          [0, 'current_letter', 'clear'],
                          [0, 'current_letter', 'set', 'a'],
                          [0, 'symbol_queue', 'set', '.-'],
                          [0, 'makenote', 64, 64, 60],
                          ['schedule', 120]],
                         true);
  Testing.ExpectEqual('generator', generator.tasker.running, true);

  Testing.ExpectFunction('generator', generator.KeyIn, generator, ['e'],
                         [[0, 'letter_queue', 'set', 'ae']],
                         true);

  Testing.ExpectFunction('generator',
                         generator.tasker.Execute, generator.tasker, [],
                         [[0, 'symbol_queue', 'set', '-'],
                          [0, 'makenote', 64, 64, 180],
                          ['schedule', 360]],
                         true);

  Testing.ExpectFunction('generator',
                         generator.tasker.Execute, generator.tasker, [],
                         [[0, 'letter_queue', 'set', 'e'],
                          [0, 'current_letter', 'set', 'e'],
                          [0, 'symbol_queue', 'set', '.'],
                          [0, 'makenote', 64, 64, 60],
                          ['schedule', 240]],
                         true);

  Testing.ExpectFunction('generator',
                         generator.tasker.Execute, generator.tasker, [],
                         [[0, 'symbol_queue', 'clear'],
                          ['schedule', 360]],
                         true);
  Testing.ExpectEqual('generator', generator.tasker.running, true);
  Testing.ExpectEqual('generator', generator.end_of_message, true);

  Testing.ExpectFunction('generator',
                         generator.tasker.Execute, generator.tasker, [],
                         [[0, 'letter_queue', 'clear'],
                          [0, 'current_letter', 'clear'],
                          ],
                         true);
  Testing.ExpectEqual('generator', generator.tasker.running, false);
});
