#ifndef __MORSE_QUEUE
#define __MORSE_QUEUE

#include "morse/morse.js"

// Morse.Queue is a queue of characters.
//
// this.queue contains the current queue.
// this.display contains the display value of the queue, which starts with the
//   previous character (because you want to see display the character you're
//   currently processing, as well as the ones you are about to process).
Morse.Queue = function() {
  this.Set = function(queue) {
    if (this.queue != queue)
      this.queue = queue;

    if (this.display != queue)
      this.display = queue;

    this.previous_character = '';
  };

  this.Clear = function() {
    this.Set('');
  };

  this.Append = function(character) {
    this.queue += character;
    this.display += character;
  };

  // Delete the last character.
  this.Delete = function() {
    if (this.queue && this.queue.length)
      this.queue = this.queue.slice(0, this.queue.length - 1);

    if (this.display && this.display.length)
      this.display = this.display.slice(0, this.display.length - 1);
  };

  this.Pop = function() {
    if (this.length) {
      if (this.previous_character != '')
        this.display = this.display.slice(1);
      this.previous_character = this.queue[0];
      this.queue = this.queue.slice(1);
      return this.previous_character;

    } else {
      this.Clear();
      return '';
    }
  }
};

Morse.Queue.prototype = {
  get length() { return this.queue.length; }
};

#endif  // __MORSE_QUEUE
