#include "patch/program_changes.js"

function _test_side(fn, data, expected) {
  return Testing.ExpectFunction(fn.name, fn, this, data, expected, true);
};

function test_program_change() {
  _test_side(new VLState().program_change, [_outlet, [12, 8]],
        [
         [_MIDI, ['vl', 'cc', 32, 11]],
         [_MIDI, ['vl', 'pc', 7]]]);

  _test_side(_reset_program_changes, [], []);

  _test_side(_output_pc, ['vl', 'ElecBass'],
        [
         [_BC_TOGGLE, [0]],
         [_CURRENT_INSTRUMENT, ["vl"]],
          [_MIDI, ['vl', 'cc', 32, 1]],
          [_MIDI, ['vl', 'pc', 111]],
         [_DISPLAY, ['instrument', 'vl']],
         [_DISPLAY, ['program', 'ElecBass']],
         ]);
  _test_side(_output_pc, ['vl', 'BowedSaw'],
        [
         [_BC_TOGGLE, [0]],
         [_CURRENT_INSTRUMENT, ["vl"]],
         [_MIDI, ['vl', 'cc', 32, 2]],
         [_MIDI, ['vl', 'pc', 51]],
         [_DISPLAY, ['instrument', 'vl']],
         [_DISPLAY, ['program', 'BowedSaw']],
         ]);

  _test_side(_output_pc, ['vl', 'ElecBass'],
        [
         [_BC_TOGGLE, [0]],
         [_CURRENT_INSTRUMENT, ["vl"]],
         [_MIDI, ['vl', 'cc', 32, 1]],
         [_MIDI, ['vl', 'pc', 111]],
         [_DISPLAY, ['instrument', 'vl']],
         [_DISPLAY, ['program', 'ElecBass']],
         ]);

  _reset_program_changes();
  _test_side(_cycle_program, [0, 0],
        [
         [_BC_TOGGLE, [0]],
         [_CURRENT_INSTRUMENT, ["vl"]],
         [_DISPLAY, ['instrument', 'vl']],
         [_DISPLAY, ['program', 'ElecBass']],
         [_DISPLAY, ['category', 'bass']],
         ]);

  _reset_program_changes();
  _test_side(_cycle_program, [0, 1],
        [
         [_BC_TOGGLE, [0]],
         [_CURRENT_INSTRUMENT, ["vl"]],
         [_MIDI, ['vl', 'cc', 32, 0]],
         [_MIDI, ['vl', 'pc', 55]],
         [_DISPLAY, ['instrument', 'vl']],
         [_DISPLAY, ['program', 'Bari_Sax']],
         [_DISPLAY, ['category', 'baritone_sax']],
         ]);

  _test_side(_cycle_program, [1, -1],
        [
         [_BC_TOGGLE, [0]],
         [_CURRENT_INSTRUMENT, ["vl"]],
         [_MIDI, ['vl', 'pc', 32]],
         [_DISPLAY, ['instrument', 'vl']],
         [_DISPLAY, ['program', 'SoprnoSx']],
         [_DISPLAY, ['category', 'soprano_sax']],
         ]);

  _test_side(_cycle_program, [2, 2],
        [
         [_BC_TOGGLE, [0]],
         [_CURRENT_INSTRUMENT, ["vl"]],
         [_MIDI, ['vl', 'pc', 34]],
         [_DISPLAY, ['instrument', 'vl']],
         [_DISPLAY, ['program', 'HeyKenG_']],
         [_DISPLAY, ['category', 'soprano_sax']],
         ]);
};
