#include "state/state.js"
#include "max/mock_patcher.js"

Testing.TestFunction(function() {
  Max.patcher = new MockPatcher();
  var state = new State(Max.patcher.js);

  var expected = [
             ['newdefault', 8, 80, 'route', ['tmidiin', 'tmidiout']],
             ['connect', 'js', 0, 'm-route-0', 0],
             ['newdefault', 8, 112, 'route', ['nano', 'pedal', 'wx']],
             ['connect', 'm-route-0', '0', 'm-route-1', 0],
             ['newdefault', 8, 144, 'tmidiin', 'nano'],
             ['connect', 'm-route-1', 0, 'm-tmidiin-2', 0],
             ['connect', 'm-tmidiin-2', 1, 'js', 0],
             ['newdefault', 92, 144, 'tmidiin', 'pedal'],
             ['connect', 'm-route-1', 1, 'm-tmidiin-3', 0],
             ['connect', 'm-tmidiin-3', 1, 'js', 0],
             ['newdefault', 182, 144, 'tmidiin', 'wx'],
             ['connect', 'm-route-1', 2, 'm-tmidiin-4', 0],
             ['connect', 'm-tmidiin-4', 1, 'js', 0],
             ['newdefault', 254, 112, 'route', ['live', 'vl']],
             ['connect', 'm-route-0', '1', 'm-route-5', 0],
             ['newdefault', 254, 144, 'tmidiout', 'live'],
             ['connect', 'm-route-5', 0, 'm-tmidiout-6', 0],
             ['newdefault', 344, 144, 'tmidiout', 'vl'],
             ['connect', 'm-route-5', 1, 'm-tmidiout-7', 0],
             ];
  function test_read(data) {
    state.Read(data);
    return Max.patcher.commands;
  };

  var test_file = 'js/state/state_test.data';
  Testing.ExpectFunction('state', test_read, this, [test_file], expected);
  Testing.ExpectFunction('state', state.Input, this,
                         [['nano', 0, 0]],
                         [[0, 'midiout', 'cc', 32, 32],
                          [0, 'midiout', 'pc', 1]], true);
  });
