#ifndef __WRITER
#define __WRITER

#include "util/array.js"

var Writer = new Object();

Writer.WriteData = function(file, data, filter_names, indent) {
  filter_names = filter_names || new Set();
  indent = indent || '';

  function wstring(x) { file.writestring(x); };
  function wline(x) { file.writeline(x); };

  switch (typeof(data)) {
   case 'undefined':
    wstring('undefined');
    break;

   case 'string':
    wstring("'" + data + "'");
    break;

   case 'object':
    if (data === null) {
      wstring('null');
      break;
    }

    var is_array = Array.Is(data);
    wline(is_array ? '[' : '{');
    for (var i in data) {
      wstring(indent + '  ');
      var skip = filter_names.Has(i);
      if (skip)
        wstring('/* ');

      if (!is_array)
        wstring("'" + i + "'" + ': ');

      if (skip) {
        wline(' ... */');
      } else {
        Writer.WriteData(file, data[i], filter_names, indent + '  ');
        wline(',');
      }
    };
    wstring(indent);
    wstring(is_array ? ']' : '}');
    break;

   default:
    file.writestring('' + data);
    break;
  }
};




#endif  // __WRITER
