#ifndef __WRITER_TEST
#define __WRITER_TEST

#include "util/writer.js"
#include "util/test_file.js"

Testing.TestFunction(function() {
  function ExpectData(data, result) {
    var file = new TestFileWriter();
    Writer.WriteData(file, data);
    Testing.ExpectEqual('writer', file.results.join(''), result);
  };

  ExpectData(undefined, 'undefined');
  ExpectData(null, 'null');
  ExpectData([], '[\n]');
  ExpectData([1], '[\n  1,\n]');
  ExpectData([1, 2], '[\n  1,\n  2,\n]');
  ExpectData({}, '{\n}');
  ExpectData({'1':'one'}, "{\n  '1': 'one',\n}");
  ExpectData({'a': [1, 2, 3], 'b': {'c': [4, 5, 6], 'e': 'hello'}},
"{\n" +
"  'a': [\n" +
"    1,\n" +
"    2,\n" +
"    3,\n" +
"  ],\n" +
"  'b': {\n" +
"    'c': [\n" +
"      4,\n" +
"      5,\n" +
"      6,\n" +
"    ],\n" +
"    'e': 'hello',\n" +
"  },\n" +
"}");
});

#endif  // __WRITER_TEST
