autowatch = 1;

#include "live_example.js"
#include "util/writer.js"
#include "util/set.js"

function WriteLOM(file, maxdepth) {
  var live = new LiveAPI(this.patcher);
  var ids_printed = {};
  var types_to_ignore = { 'list': 1, 'tuple': 1 };
  var children_to_ignore = { 'canonical_parent': 1};

  function Write(depth, indent, path) {
    live.path = path;

    var new_indent = indent + '  ';
    var children = live.children;

    file.writeline(live.id + ' (' + live.type + ')');
    if (depth >= maxdepth || types_to_ignore[live.type] || ids_printed[live.id])
      return;

    ids_printed[live.id] = 1;
    for (var i = 0; i < children.length; ++i) {
      var child = children[i];
      if (children_to_ignore[child])
        continue;
      file.writestring(new_indent + child + ' = ');
      Write(depth + 1, new_indent, path.concat([child]));
      file.writeline('');
    }
  };

  Write(0, '', []);
};

function write(filename, depth) {
  WriteLOM(new File(filename, 'write'), depth || 1);
};

function test_callback(args)
{
  post("callback arrived from", this, ":", args, "\n");
  if (this.name)
    post("name is", this.name, "\n");
};

post('compiled write_lom.jso\n');
