#ifndef __CLONE
#define __CLONE

var _clone = {
  //public method
  clone: function(oldObject) {
    var tempClone = {};

    if (typeof(oldObject) == 'object')
      for (prop in oldObject)
        // for array use private method clone_array
        if ((typeof(oldObject[prop]) == 'object') &&
            (oldObject[prop]).__isArray)
          tempClone[prop] = this.clone_array(oldObject[prop]);
    // for object make recursive call to clone
        else if (typeof(oldObject[prop]) == 'object')
          tempClone[prop] = this.clone(oldObject[prop]);
    // normal (non-object type) members
        else
          tempClone[prop] = oldObject[prop];

    return tempClone;
  },

  //private method (to copy array of objects) - clone will use this internally
  clone_array: function(oldArray) {
    var tempClone = [];

    for (var arrIndex = 0; arrIndex <= oldArray.length; arrIndex++)
      if (typeof(oldArray[arrIndex]) == 'object')
        tempClone.push(this.clone(oldArray[arrIndex]));
      else
        tempClone.push(oldArray[arrIndex]);

    return tempClone;
  }
};

#endif  // __CLONE
