#ifndef __SCENES
#define __SCENES

var _songs;
var _scene_list;
var _song_table;
var _current_song_name;

function _set_song_data(songs) {
  _songs = songs;
  _scene_list = _make_scene_list(songs);
  _song_table = _make_song_table(songs);
  _current_song_name = ''
};

function _run_scene(scene_name, song_name) {
  _current_song_name = song_name || _current_song_name;

  if ((!_current_song_name in _song_table))
    throw new RangeError('No song named ' + _current_song_name);

  var scene_table = _song_table[_current_song_name];
  if (!(scene_name in scene_table))
    throw new RangeError('No scene named ' + scene);

  var scene = scene_table[scene_name];

  _outlet(_DISPLAY, ['song', _current_song_name]);
  _outlet(_DISPLAY, ['scene', scene_name]);
  for (var i = 0; i < scene.length; ++i) {
    var op = scene[i];
    var fn = op[0];
    fn.apply(this, op.slice(1));
  }
};

function _run_current_scene() {
  _run_scene.apply(this, _deref(_scene_list, 1));
};

function _next_scene(delta) {
  _circular(_scene_list, delta);
  _run_current_scene();
};

function _reset_scene(songs) {
  _set_song_data(songs);
  _scene_list[0] = 0;
  _run_current_scene();
};

#endif  // __SCENES
