#ifndef __STATE
#define __STATE

function _reset_groups() {
  var groups = new Groups(_read_data('groups.data'),
                          _read_data('categories.data'));
  _patch_manager = new PatchManager(groups, new ProgramChanges());
  _patch_manager.output_state(_outlet);
};

_reset_groups();

function State() {
  var connections = new Connections();
  var groups = new Groups();
  var maps = [];
  var midi = new Midi();
  var read_context;
  var songs = new Songs();

  this.read = function(name) {
    var state = _read_data(name, read_context);
  };

  this.cycle = function(type, delta) {
    if (delta == undefined)
      delta = 1;

    if (type == _SCENE) {
      songs.cycle(delta);
    } else {
      groups.cycle(type, delta);
      this._reset_reset_flag();
    }
  };

  this.read_context = {
    // Constants for cycling.
    'group':    _GROUP,
    'category': _CATEGORY,
    'patch':    _PATCH,
    'scene':    _SCENE,

    // Functions.
    'Cycle':         bind(this, 'cycle'),
    'Read':          this.read,

    'Connect':       bind(connections, 'replace'),

    'Jump':          bind(songs, 'scene'),

    'PopMap':        bind(maps, 'shift'),
    'PushMap':       bind(maps, 'unshift'),
    'SetMap':        bind(maps, 'replace'),

    'PatchChange':   bind(program_changes, 'change'),

    'Maps': function(_) {  // Not needed?
      var maps = arrayfromargs(arguments);
      var result = {};
      for (var m in maps) {
        var map = maps[m];
        for (var key in map)
          result[key] = map[key];
      }
      return result;
    },
  };
};

#endif  // __STATE
