
#include "../circular.js"

testf(function() {
  var group_data =
    [
      ['reeds',
       ['clarinet', ['vl', 'Clarinet'], ['vl', 'Bass Cl']],
       ['alto sax', ['vl', 'Alto'], ['vl', 'MyAlto']],
      ],
      ['brass',
       ['horns', ['vl', 'Horn']],
      ]
    ];

  var groups = Circulate(2)(group_data);
  function do_test(song, section, patch) {
    _test_equal('groups', groups.get(1).name, song);
    _test_equal('groups', groups.get(2).name, section);
    _test_equal('groups', groups.get(3)[1], patch);
  };

  do_test('reeds', 'clarinet', 'Clarinet');

  groups.cycle();
  do_test('brass', 'horns', 'Horn');

  groups.cycle();
  do_test('reeds', 'clarinet', 'Clarinet');

  groups.get(1).cycle();
  do_test('reeds', 'alto sax', 'Alto');

  groups.get(1).cycle(-1);
  do_test('reeds', 'clarinet', 'Clarinet');

  groups.get(2).cycle(-1);
  do_test('reeds', 'clarinet', 'Bass Cl');

  groups.get(1).cycle();
  do_test('reeds', 'alto sax', 'Alto');

  groups.get(2).cycle();
  do_test('reeds', 'alto sax', 'MyAlto');

  groups.cycle();
  do_test('brass', 'horns', 'Horn');
});
